// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'analyzer.dart';

class Document {
  List<Field> fields = [];
  Document add(Field field) {
    fields.add(field);
    return this;
  }
  Document append(String name, String text, Analyzer analyzer) {
    add(new Field(name, text, analyzer));
    return this;
  }

  String get(String name) => fields.where((e) => e.name == name).toList()[0].text;
}
class Field {
  final String name;
  final String text;
  final Analyzer analyzer;
  Field(this.name, this.text, this.analyzer);
}