// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'index_reader.dart';

class FieldFacet {
  static Map<String,Set<int>> getCount(Set<int> docSet, String field, IndexReader reader) {
    var acc = <String,Set<int>>{};
    for (int docId in docSet) {
      String v = reader.getData(field)[docId];
      if (acc[v] == null) {
        acc[v] = new Set<int>()..add(docId);
      } else {
        acc[v] = acc[v]..add(docId);
      }
    }
    var l = <Map<String,Set<int>>>[];
    for (var k in acc.keys) {
      var x = <String,Set<int>>{};
      x[k] = acc[k];
      l.add(x);
    }
    l.sort((a, b) => b.values.toList()[0].length - a.values.toList()[0].length);
    return new Map.fromIterable(l, key: (e) => (e as Map).keys.toList()[0], value: (e) => (e as Map).values.toList()[0]);
  }
}