// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'analyzer.dart';
import 'query.dart';

class Highlighter {
  static String getSnippet(BoolQuery query, String field,
      String text, Analyzer analyzer, {int size: 100, String separator: ''}) {
    List<String> ret = [];
    int endIndex = (text.length < size) ? text.length : size;
    Iterable<String> tokens = analyzer.getTokens(text.substring(0, endIndex));
    Iterable<TermQuery> qList = query.termQueries.where((e) => e.term.field == field);
    for (var token in tokens) {
      List<TermQuery> tqs = qList.where((e) => e.term.text == token).toList();
      TermQuery tq = (tqs.isEmpty) ? null : tqs[0];
      if (tq != null) {
        ret.add('<b>');
        ret.add(token);
        ret.add('</b>');
      } else {
        ret.add(token);
      }
      ret.add(separator);
    }
    if (separator.length > 0) ret.removeLast();
    return ret.join();
  }
}