// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'package:ducene/ducene.dart';
import 'package:test/test.dart';

void main() {
  group('A group of analyzer', () {
    NGramAnalyzer uniGramAnalyzer;
    NGramAnalyzer biGramAnalyzer;
    ShingleAnalyzer wordUniGramAnalyzer;
    ShingleAnalyzer wordBiGramAnalyzer;
    WhitespaceAnalyzer whitespaceAnalyzer;
    ShingleAnalyzer biShingleAnalyzer;
    ShingleAnalyzer triShingleAnalyzer;

    setUp(() {
      uniGramAnalyzer = new NGramAnalyzer(1);
      biGramAnalyzer = new NGramAnalyzer(2);
      wordUniGramAnalyzer = new ShingleAnalyzer(uniGramAnalyzer, 2, '');
      wordBiGramAnalyzer = new ShingleAnalyzer(biGramAnalyzer, 2, '');
      whitespaceAnalyzer = new  WhitespaceAnalyzer();
      biShingleAnalyzer = new ShingleAnalyzer(whitespaceAnalyzer, 2, ' ');
      triShingleAnalyzer = new ShingleAnalyzer(whitespaceAnalyzer, 3, ' ');
    });

    test('test001', () {
      expect(uniGramAnalyzer.getTokens('aaa bbb'),
          equals(['a', 'a', 'a', ' ', 'b', 'b', 'b']));
    });

    test('test002', () {
      expect(biGramAnalyzer.getTokens('aaa bbb'),
          equals(['aa', 'aa', 'a ', ' b', 'bb', 'bb']));
    });

    test('test003', () {
      expect(wordUniGramAnalyzer.getTokens('aaa bbb').toList(),
          equals(['aa', 'aa', 'a ', ' b', 'bb', 'bb', 'b']));
    });

    test('test004', () {
      expect(wordBiGramAnalyzer.getTokens('aaa bbb').toList(),
          equals(['aaaa', 'aaa ', 'a  b', ' bbb', 'bbbb', 'bb']));
    });

    test('test005', () {
      expect(whitespaceAnalyzer.getTokens('Please divide this sentence into shingles'),
          equals(['please', 'divide', 'this', 'sentence', 'into', 'shingles']));
    });

    test('test006', () {
      expect(biShingleAnalyzer.getTokens('Please divide this sentence into shingles'),
          equals(['please divide', 'divide this', 'this sentence', 'sentence into', 'into shingles', 'shingles']));
    });

    test('test007', () {
      expect(triShingleAnalyzer.getTokens('Please divide this sentence into shingles'),
          equals(['please divide this', 'divide this sentence', 'this sentence into', 'sentence into shingles', 'into shingles', 'shingles']));
    });
  });
}

